/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: gpi.h                                                           |
| DESCRIPTION: Function prototypes for gpi.c.                           |
|                                                                       |    
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/

void gpi_SelectColonist(Population * pop,Individual * ind); /*funcdef*/
void gpi_InductImmigrant(Population *pop,Individual * ind); /*funcdef*/
void gpi_GetGPPointers(Population  ** popptr,            /*funcdef*/
                       StartupInfo ** paramptr);     /*funcdef*/
int gpi_TerminationQuery(int gen); /*funcdef*/
void gpi_SetMsgHdrElmt(int index, MSGHDRTYPE value) ; /*funcdef*/
void gpi_SetMsgHdrEmpty(void) ; /*funcdef*/
MSGHDRTYPE * gpi_GetOutMsgHdrPtr(void); /*funcdef*/
void gpi_SetMsgHdr(MSGHDRTYPE m0, MSGHDRTYPE m1,                /* funcdef */
                   MSGHDRTYPE m2, MSGHDRTYPE m3,                /* funcdef */
                   MSGHDRTYPE m4, MSGHDRTYPE m5,                /* funcdef */ 
                   MSGHDRTYPE m6, MSGHDRTYPE m7);           /* funcdef */
MSGHDRTYPE gpi_GetMsgHdrElmt(int index) ; /*funcdef*/
MSGHDRTYPE *gpi_GetMsgHdr(void) ; /*funcdef*/
void gpi_SetLengthInMsgHdr(int length); /*funcdef*/
void gpi_PopCreation(Population * pop,int whoiam); /*funcdef*/
void gpi_EvaluateGeneration(int whoiam,int gen,Population *popptr); /*funcdef*/
void gpi_ReproducePopulation(int counter); /*funcdef*/
void gpi_DoEndOfGenMessage(int counter, Population * pop); /*funcdef*/
void gpi_DoEurekaMessage(int counter, Population * pop); /*funcdef*/
void gpi_SendTrace(char * str);         /*funcdef*/
void gpi_SendError(char *str);          /*funcdef*/
void gpi_SendFastHeartbeat(void);       /*funcdef*/
void gpi_SendHeartbeat(void);           /*funcdef*/
void gpi_SendEndOfGen(EndGenInfo * eog); /*funcdef*/
void gpi_SendEureka(EurekaInfo * eureka) ; /*funcdef*/
void gpi_SetTypeInMsgHdr(int type); /*funcdef*/
void gpi_PreparePopulationForExportStep(void);  /*funcdef*/
void gpi_PreparePopulationForImportStep(void);  /*funcdef*/

