/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: newops.h                                                        |
| DESCRIPTION: Function prototypes for newops.c.                        |
|                                                                       |       
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/

#define LEXUS 1
#define PINTO 2

void SafeCopySubtree(                                       /*funcdef*/
                        Branch   *from_br,                  /*funcdef*/
                        int             from_start,         /*funcdef*/
                        int             from_end,           /*funcdef*/
                        Branch   *to_br,                    /*funcdef*/
                        int             to_start);          /*funcdef*/

void CopyFunctionVector(                                    /*funcdef*/
                        Branch   *br1,                      /*funcdef*/
                        Branch   *br2);                     /*funcdef*/

void MoveBranch(       Branch   *src,                       /*funcdef*/
                        Branch   *dest);                    /*funcdef*/

/* ANSI prototypes for new operations.  Slight violation of spec
   in the sense that these return int rather than void: a return
   value less than 0 indicates failure.  */
int DoBranchCreation(Individual * child, Individual * parent);          /*funcdef*/
int DoBranchDuplication(Individual * child, Individual * parent);       /*funcdef*/
int DoBranchDeletion(Individual * child, Individual * parent);          /*funcdef*/
int DoArgumentDuplication(Individual * child, Individual * parent);     /*funcdef*/
int DoArgumentDeletion(Individual * child, Individual * parent);        /*funcdef*/
int DoIterationPerformingBranchCreation(Individual * child,Individual * parent);





















