/*======================================================================+
| PGPC: Parallel Genetic Programming in C                               |
| (c) 1995 Genetic Algorithm Technology Corp. all rights reserved       |
|   written by David Andre                                              |
+======================================================================*/
/*======================================================================+
| FILE: prbproto.h                                                      |
| DESCRIPTION: Function prototypes for specific problem code.           |
|                                                                       |
| REVISIONS:                                                            |
| Jan 24, 1995:  Works as of today, no known bugs.                      |
+======================================================================*/


void init_macro(Branch *br); /*funcdef*/
int GetBranchSize(int brn); /*funcdef - problem - GetBranchSize*/
int GetBranchWeight(int brn); /*funcdef*/
GTYPE reg_func(GTYPE *arr);/*funcdef*/
void CreateFitnessCases (Population *pop);/*funcdef*/
void    MakeFunctionTable(Population * pop);/*funcdef*/
void skip_subtree(Branch *br);/*funcdef*/
int EvalFitnessOfDude(Individual * ind,Population *pop);/*funcdef*/
void EvalOutSampleFitnessOfDude(Individual * ind,Population *pop); /*funcdef*/
GTYPE Eval(Branch * br,Population *pop); /*funcdef - dgpc - Eval*/
GTYPE RAND_CODE(void);  /*randomFloat is in the shar.c file....*/
int GetResidueNumFromChar(char ch); /*funcdef*/
void PrintProblemSpecificInfo(FILE *fp,Population *pop); /*funcdef*/
void PrintProblemSpecificInfoForBest(FILE *fp,Population *pop); /*funcdef*/
void InitFitnessCases(Population *pop);

void PrintProblemSpecificIndividual(Individual * ind,Population * pop);
#ifdef USE_USER_TERMINATION
#if USE_USER_TERMINATION ==1
int UserTermination(int gen,float fit,Population *pop);
#endif
#endif


